#ifndef	_gaussInterp_
#define	_gaussInterp_

typedef struct IntTab_t {
	short d0;
	short d1;
	short d2;
	short d3;
} IntTab;

extern void makeGaussTbl();
extern IntTab gaussTab[256];

__inline int gaussInpterP(unsigned int delta, short *src)
{
	#define	_shift	(0)
	#define	_shift2	(15)
	IntTab *ESI = &gaussTab[ (delta>>8) ];
	return	(
			(int)((int)(ESI->d3 * src[-3])>>_shift)+
			(int)((int)(ESI->d2 * src[-2])>>_shift)+
			(int)((int)(ESI->d1 * src[-1])>>_shift)+
			(int)((int)(ESI->d0 * src[-0])>>_shift)+
			0 ) >> _shift2 ;
}

#endif

