#include "../snes9x/snes9x.h"
#include "../snes9x/ppu.h"
#include "DirectX.h"

extern char ROMFileName[];
extern char RecentROMFileName[];
void SetRecentFileMenu();
void StateSaveLoadMenuSet();

extern "C" const char *S9xBasename (const char *f);

extern bool8 TransparencyFlag;

extern int FullscreenDisplayModeIndexDouble16;
extern int DoubleRenderingModes16;

extern unsigned char dRendering;
extern unsigned char ForceWindowedDirectDrawClipper;

static int i, i2;

//j[ԃZbg֐
void S9xwSetMenuStatus(HMENU hAppMenu, HMENU hSysMenu)
{
	//not supported yet
	EnableMenuItem(hAppMenu, ID_OPTION_CHEATCODE, MFS_GRAYED);

	/* t@C */
	//ǂݍ
	EnableMenuItem(hAppMenu, ID_FILE_OPEN, GUI.PauseEmulation ? MFS_GRAYED : MFS_ENABLED);
	//ŋߓǂݍ񂾃t@C
	SetRecentFileMenu();
	//ŋߓǂݍ񂾃t@C
	CheckMenuItem(hAppMenu, ID_FILE_DISABLEOUTPUTSRAM, (Xppsystem.DisableOutputSram ? MFS_CHECKED : MFS_UNCHECKED));

	switch(XppMovie.Replay_Recode_Mode)
	{
		case 0:
			CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAYRECODE_TYPE_1, ID_FILE_REPLAYRECODE_TYPE_2, ID_FILE_REPLAYRECODE_TYPE_1, MF_BYCOMMAND);
			break;
		case 1:
			CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAYRECODE_TYPE_1, ID_FILE_REPLAYRECODE_TYPE_2, ID_FILE_REPLAYRECODE_TYPE_2, MF_BYCOMMAND);
			break;
		default:
			CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAYRECODE_TYPE_1, ID_FILE_REPLAYRECODE_TYPE_2, ID_FILE_REPLAYRECODE_TYPE_1, MF_BYCOMMAND);
			break;
	}

	if(XppMovie.Replay_status == MOVIE_NONE && !Xppcode.CheatNumRock)
	{

		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_0, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_1, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_2, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_3, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_4, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_5, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_6, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_7, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_8, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_9, MFS_ENABLED);
	}
	else
	{
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_0, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_1, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_2, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_3, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_4, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_5, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_6, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_7, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_8, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_SLOT_9, MFS_GRAYED);
	}				

	switch(XppMovie.Replay_Slot)
	{
		case 0:
			CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAY_SLOT_0, ID_FILE_REPLAY_SLOT_9, ID_FILE_REPLAY_SLOT_0, MF_BYCOMMAND);
			break;
		case 1:
			CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAY_SLOT_0, ID_FILE_REPLAY_SLOT_9, ID_FILE_REPLAY_SLOT_1, MF_BYCOMMAND);
			break;
		case 2:
			CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAY_SLOT_0, ID_FILE_REPLAY_SLOT_9, ID_FILE_REPLAY_SLOT_2, MF_BYCOMMAND);
			break;
		case 3:
			CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAY_SLOT_0, ID_FILE_REPLAY_SLOT_9, ID_FILE_REPLAY_SLOT_3, MF_BYCOMMAND);
			break;
		case 4:
			CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAY_SLOT_0, ID_FILE_REPLAY_SLOT_9, ID_FILE_REPLAY_SLOT_4, MF_BYCOMMAND);
			break;
		case 5:
			CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAY_SLOT_0, ID_FILE_REPLAY_SLOT_9, ID_FILE_REPLAY_SLOT_5, MF_BYCOMMAND);
			break;
		case 6:
			CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAY_SLOT_0, ID_FILE_REPLAY_SLOT_9, ID_FILE_REPLAY_SLOT_6, MF_BYCOMMAND);
			break;
		case 7:
			CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAY_SLOT_0, ID_FILE_REPLAY_SLOT_9, ID_FILE_REPLAY_SLOT_7, MF_BYCOMMAND);
			break;
		case 8:
			CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAY_SLOT_0, ID_FILE_REPLAY_SLOT_9, ID_FILE_REPLAY_SLOT_8, MF_BYCOMMAND);
			break;
		case 9:
			CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAY_SLOT_0, ID_FILE_REPLAY_SLOT_9, ID_FILE_REPLAY_SLOT_9, MF_BYCOMMAND);
			break;
		default:
			CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAY_SLOT_0, ID_FILE_REPLAY_SLOT_9, ID_FILE_REPLAY_SLOT_0, MF_BYCOMMAND);
			break;
	}

	if(CPU.OldTiming == FALSE)
	CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAYTIMING_1, ID_FILE_REPLAYTIMING_2, ID_FILE_REPLAYTIMING_1, MF_BYCOMMAND);
	else
	CheckMenuRadioItem(hAppMenu, ID_FILE_REPLAYTIMING_1, ID_FILE_REPLAYTIMING_2, ID_FILE_REPLAYTIMING_2, MF_BYCOMMAND);

	if(GUI.StopEmulation)
	{
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_PLAY, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_RECODE, MFS_GRAYED);	
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_STOP, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_RESUME_LOAD, MFS_GRAYED);	
		EnableMenuItem(hAppMenu, ID_FILE_REPLAY_RESUME_SAVE, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_REPLAYRECODE_TYPE_1, MFS_ENABLED);	
		EnableMenuItem(hAppMenu, ID_FILE_REPLAYRECODE_TYPE_2, MFS_ENABLED);

		EnableMenuItem(hAppMenu, ID_FILE_REPLAYTIMING_1, MFS_ENABLED);	
		EnableMenuItem(hAppMenu, ID_FILE_REPLAYTIMING_2, MFS_ENABLED);
	}
	else
	{
		EnableMenuItem(hAppMenu, ID_FILE_REPLAYTIMING_1, MFS_GRAYED);	
		EnableMenuItem(hAppMenu, ID_FILE_REPLAYTIMING_2, MFS_GRAYED);

		if(XppMovie.Replay_status == MOVIE_NONE && !Xppcode.CheatNumRock)
		{
			EnableMenuItem(hAppMenu, ID_FILE_REPLAY_PLAY, MFS_ENABLED);
			EnableMenuItem(hAppMenu, ID_FILE_REPLAY_RECODE, MFS_ENABLED);	
			EnableMenuItem(hAppMenu, ID_FILE_REPLAY_STOP, MFS_GRAYED);
			EnableMenuItem(hAppMenu, ID_FILE_REPLAY_RESUME_LOAD, MFS_ENABLED);	
			EnableMenuItem(hAppMenu, ID_FILE_REPLAY_RESUME_SAVE, MFS_GRAYED);
			EnableMenuItem(hAppMenu, ID_FILE_REPLAYRECODE_TYPE_1, MFS_ENABLED);	
			EnableMenuItem(hAppMenu, ID_FILE_REPLAYRECODE_TYPE_2, MFS_ENABLED);
		}
		else
		if(XppMovie.Replay_status == MOVIE_NONE && Xppcode.CheatNumRock)
		{
			EnableMenuItem(hAppMenu, ID_FILE_REPLAY_PLAY, MFS_GRAYED);
			EnableMenuItem(hAppMenu, ID_FILE_REPLAY_RECODE, MFS_GRAYED);	
			EnableMenuItem(hAppMenu, ID_FILE_REPLAY_STOP, MFS_GRAYED);
			EnableMenuItem(hAppMenu, ID_FILE_REPLAY_RESUME_LOAD, MFS_GRAYED);	
			EnableMenuItem(hAppMenu, ID_FILE_REPLAY_RESUME_SAVE, MFS_GRAYED);
			EnableMenuItem(hAppMenu, ID_FILE_REPLAYRECODE_TYPE_1, MFS_ENABLED);	
			EnableMenuItem(hAppMenu, ID_FILE_REPLAYRECODE_TYPE_2, MFS_ENABLED);
		}
		else
		{
			EnableMenuItem(hAppMenu, ID_FILE_REPLAY_PLAY, MFS_GRAYED);
			EnableMenuItem(hAppMenu, ID_FILE_REPLAY_RECODE, MFS_GRAYED);	
			EnableMenuItem(hAppMenu, ID_FILE_REPLAY_STOP, MFS_ENABLED);
			EnableMenuItem(hAppMenu, ID_FILE_REPLAY_RESUME_LOAD, MFS_ENABLED);	
			EnableMenuItem(hAppMenu, ID_FILE_REPLAY_RESUME_SAVE, MFS_ENABLED);
			EnableMenuItem(hAppMenu, ID_FILE_REPLAYRECODE_TYPE_1, MFS_GRAYED);	
			EnableMenuItem(hAppMenu, ID_FILE_REPLAYRECODE_TYPE_2, MFS_GRAYED);
		}
	}

	/* IvV */
	//Sʕ\
	CheckMenuItem(hAppMenu, ID_OPTION_FULLSCREEN, (GUI.FullScreen || (DirectX.Windowed && DirectX.Depth == 8)) ? MFS_CHECKED : MFS_UNCHECKED);
	EnableMenuItem(hAppMenu, ID_OPTION_FULLSCREEN, ((DirectX.Windowed && DirectX.Depth == 8)) ? MFS_GRAYED : MFS_ENABLED);
	//EChETCY
	EnableMenuItem(hAppMenu, ID_OPTION_ADJUSTWINDOW, GUI.PauseEmulation ? MFS_GRAYED : MFS_ENABLED);
	//L΂\
//	CheckMenuItem(hAppMenu, ID_OPTION_STRETCH, GUI.Stretch ? MFS_CHECKED : MFS_UNCHECKED);
	//ݒ
	EnableMenuItem(hAppMenu, ID_OPTION_CONFIG, GUI.PauseEmulation ? MFS_GRAYED : MFS_ENABLED);
	//Snes9x ݒύXL[
	CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_0, Settings.DisableHDMA ? MFS_UNCHECKED : MFS_CHECKED);
	CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_6, Settings.SwapJoypads ? MFS_CHECKED : MFS_UNCHECKED);
	CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_8, Settings.BGLayering ? MFS_CHECKED : MFS_UNCHECKED);
	CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_9, TransparencyFlag ? MFS_CHECKED : MFS_UNCHECKED);
	CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_BACK, Settings.DisableGraphicWindows ? MFS_UNCHECKED : MFS_CHECKED);
	CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_PAUSE, GUI.PauseEmulation ? MFS_CHECKED : MFS_UNCHECKED);
	CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_APPLYCHEATS, (Settings.ApplyCheats ? MFS_CHECKED : MFS_UNCHECKED));

	CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_TURBO, Settings.TurboMode ? MFS_CHECKED : MFS_UNCHECKED);

	//AD
	switch(Options.Adjustwindow)
	{
		case 0:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_0, MF_BYCOMMAND);
			break;

		case 1:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_1, MF_BYCOMMAND);
			break;

		case 2:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_2, MF_BYCOMMAND);
			break;

		case 3:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_3, MF_BYCOMMAND);
			break;

		case 4:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_4, MF_BYCOMMAND);
			break;

		case 5:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_5, MF_BYCOMMAND);
			break;

		case 6:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_6, MF_BYCOMMAND);
			break;

		case 7:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_7, MF_BYCOMMAND);
			break;

		case 8:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_8, MF_BYCOMMAND);
			break;

		case 9:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_9, MF_BYCOMMAND);
			break;

		case 10:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_10, MF_BYCOMMAND);
			break;

		case 11:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_11, MF_BYCOMMAND);
			break;

		case 12:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_12, MF_BYCOMMAND);
			break;

		case 13:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_13, MF_BYCOMMAND);
			break;

		case 14:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_14, MF_BYCOMMAND);
			break;

		case 15:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_15, MF_BYCOMMAND);
			break;

		case 16:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_16, MF_BYCOMMAND);
			break;

		case 17:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_17, MF_BYCOMMAND);
			break;

		case 18:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_18, MF_BYCOMMAND);
			break;

		case 19:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_19, MF_BYCOMMAND);
			break;

		case 20:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_20, MF_BYCOMMAND);
			break;

		case 21:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_21, MF_BYCOMMAND);
			break;

		case 22:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_22, MF_BYCOMMAND);
			break;

		case 23:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_23, MF_BYCOMMAND);
			break;

		default:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_ADJUSTWINDOW_0, ID_OPTION_ADJUSTWINDOW_23, ID_OPTION_ADJUSTWINDOW_0, MF_BYCOMMAND);
			break;
	}

	switch(Options.Full_Adjustwindow)
	{
		case 0:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_0, MF_BYCOMMAND);
			break;

		case 1:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_1, MF_BYCOMMAND);
			break;

		case 2:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_2, MF_BYCOMMAND);
			break;

		case 3:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_3, MF_BYCOMMAND);
			break;

		case 4:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_4, MF_BYCOMMAND);
			break;

		case 5:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_5, MF_BYCOMMAND);
			break;

		case 6:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_6, MF_BYCOMMAND);
			break;

		case 7:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_7, MF_BYCOMMAND);
			break;

		case 8:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_8, MF_BYCOMMAND);
			break;

		case 9:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_9, MF_BYCOMMAND);
			break;

		case 10:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_10, MF_BYCOMMAND);
			break;

		case 11:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_11, MF_BYCOMMAND);
			break;

		case 12:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_12, MF_BYCOMMAND);
			break;

		case 13:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_13, MF_BYCOMMAND);
			break;

		case 14:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_14, MF_BYCOMMAND);
			break;

		case 15:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_15, MF_BYCOMMAND);
			break;

		case 16:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_16, MF_BYCOMMAND);
			break;

		case 17:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_17, MF_BYCOMMAND);
			break;

		case 18:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_18, MF_BYCOMMAND);
			break;

		case 19:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_19, MF_BYCOMMAND);
			break;

		case 20:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_20, MF_BYCOMMAND);
			break;

		case 21:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_21, MF_BYCOMMAND);
			break;

		case 22:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_22, MF_BYCOMMAND);
			break;

		case 23:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_23, MF_BYCOMMAND);
			break;

		default:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_ADJUSTWINDOW_0, ID_OPTION_FULL_ADJUSTWINDOW_23, ID_OPTION_FULL_ADJUSTWINDOW_0, MF_BYCOMMAND);
			break;
	}

	switch(FullscreenDisplayModeIndexDouble16)
	{
		case 0:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_0, MF_BYCOMMAND);
			break;
		case 1:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_1, MF_BYCOMMAND);
			break;
		case 2:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_2, MF_BYCOMMAND);
			break;
		case 3:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_3, MF_BYCOMMAND);
			break;
		case 4:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_4, MF_BYCOMMAND);
			break;
		case 5:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_5, MF_BYCOMMAND);
			break;
		case 6:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_6, MF_BYCOMMAND);
			break;
		case 7:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_7, MF_BYCOMMAND);
			break;
		case 8:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_8, MF_BYCOMMAND);
			break;
		case 9:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_9, MF_BYCOMMAND);
			break;
		case 10:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_10, MF_BYCOMMAND);
			break;
		case 11:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_11, MF_BYCOMMAND);
			break;
		case 12:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_12, MF_BYCOMMAND);
			break;
		case 13:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_13, MF_BYCOMMAND);
			break;
		case 14:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_14, MF_BYCOMMAND);
			break;
		default:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_FULL_SCREEN_SIZE_0, ID_OPTION_FULL_SCREEN_SIZE_14, ID_OPTION_FULL_SCREEN_SIZE_0, MF_BYCOMMAND);
			break;
	}

	switch(DoubleRenderingModes16)
	{
		case 1:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_2X_HARDWARE, ID_OPTION_2X_INTERLACE, ID_OPTION_2X_HARDWARE, MF_BYCOMMAND);
			break;

		case 2:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_2X_HARDWARE, ID_OPTION_2X_INTERLACE, ID_OPTION_2X_SOFTWARE, MF_BYCOMMAND);
			break;
			

		case 3:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_2X_HARDWARE, ID_OPTION_2X_INTERLACE, ID_OPTION_2X_SCANLINES, MF_BYCOMMAND);
			break;

		case 4:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_2X_HARDWARE, ID_OPTION_2X_INTERLACE, ID_OPTION_2X_EAGLE, MF_BYCOMMAND);
			break;

		case 5:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_2X_HARDWARE, ID_OPTION_2X_INTERLACE, ID_OPTION_2X_SAI, MF_BYCOMMAND);
			break;

		case 6:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_2X_HARDWARE, ID_OPTION_2X_INTERLACE, ID_OPTION_SUPER_2X_SAI, MF_BYCOMMAND);
			break;

		case 7:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_2X_HARDWARE, ID_OPTION_2X_INTERLACE, ID_OPTION_SCALE_2X_SAI, MF_BYCOMMAND);
			break;

		case 8:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_2X_HARDWARE, ID_OPTION_2X_INTERLACE, ID_OPTION_2X_TVMODE, MF_BYCOMMAND);
			break;

		case 9:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_2X_HARDWARE, ID_OPTION_2X_INTERLACE, ID_OPTION_2X_HQ2X, MF_BYCOMMAND);
			break;

		case 10:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_2X_HARDWARE, ID_OPTION_2X_INTERLACE, ID_OPTION_2X_LQ2X, MF_BYCOMMAND);
			break;

		case 11:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_2X_HARDWARE, ID_OPTION_2X_INTERLACE, ID_OPTION_2X_INTERLACE_SCANLINES, MF_BYCOMMAND);
			break;

		case 12:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_2X_HARDWARE, ID_OPTION_2X_INTERLACE, ID_OPTION_2X_INTERLACE, MF_BYCOMMAND);
			break;

		default:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_2X_HARDWARE, ID_OPTION_2X_INTERLACE, ID_OPTION_2X_HARDWARE, MF_BYCOMMAND);
			break;
	}

	switch(Options.ScanLinesEffect)
	{
		case 1:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SCANLINES_SET_100, ID_OPTION_SCANLINES_SET_000, ID_OPTION_SCANLINES_SET_100, MF_BYCOMMAND);
			break;
		case 2:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SCANLINES_SET_100, ID_OPTION_SCANLINES_SET_000, ID_OPTION_SCANLINES_SET_075, MF_BYCOMMAND);
			break;
		case 3:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SCANLINES_SET_100, ID_OPTION_SCANLINES_SET_000, ID_OPTION_SCANLINES_SET_050, MF_BYCOMMAND);
			break;
		case 4:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SCANLINES_SET_100, ID_OPTION_SCANLINES_SET_000, ID_OPTION_SCANLINES_SET_025, MF_BYCOMMAND);
			break;
		case 5:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SCANLINES_SET_100, ID_OPTION_SCANLINES_SET_000, ID_OPTION_SCANLINES_SET_000, MF_BYCOMMAND);
			break;
		default:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SCANLINES_SET_100, ID_OPTION_SCANLINES_SET_000, ID_OPTION_SCANLINES_SET_100, MF_BYCOMMAND);
			break;
	}

	//Mode7Interpolate
	CheckMenuItem(hAppMenu, ID_OPTION_MODE7INTERPOLATE, (Settings.Mode7Interpolate ? MFS_CHECKED : MFS_UNCHECKED));

	//AltScreenEffect
	CheckMenuItem(hAppMenu, ID_OPTION_2X_ALT_SCREEN_EFFECT, (Options.AltScreenEffect ? MFS_CHECKED : MFS_UNCHECKED));

    //Display Setup
	CheckMenuItem(hAppMenu, ID_OPTION_DIRECTSCREENRENDERING, (dRendering ? MFS_CHECKED : MFS_UNCHECKED));
	CheckMenuItem(hAppMenu, ID_OPTION_DISABLEHARDWARESCALE, (DirectX.DisableHardwareScale ? MFS_CHECKED : MFS_UNCHECKED));
	CheckMenuItem(hAppMenu, ID_OPTION_FORCEWINDOWEDDIRECTDRAWCLIPPER, (ForceWindowedDirectDrawClipper ? MFS_CHECKED : MFS_UNCHECKED));
	CheckMenuItem(hAppMenu, ID_OPTION_DOUBLEBUFFERING, (GUI.DoubleBuffered ? MFS_CHECKED : MFS_UNCHECKED));
	CheckMenuItem(hAppMenu, ID_OPTION_OFFSCREENVRAM, (DirectX.OffScreenVRAM ? MFS_CHECKED : MFS_UNCHECKED));
	CheckMenuItem(hAppMenu, ID_OPTION_BACKBUFFERVRAM, (DirectX.BackBufferVRAM ? MFS_CHECKED : MFS_UNCHECKED));

	//{[x
	switch(Options.VolumeLevel)
	{
		case 1:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_VL1, ID_OPTION_VL5, ID_OPTION_VL1, MF_BYCOMMAND);
			break;

		case 2:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_VL1, ID_OPTION_VL5, ID_OPTION_VL2, MF_BYCOMMAND);
			break;

		case 3:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_VL1, ID_OPTION_VL5, ID_OPTION_VL3, MF_BYCOMMAND);
			break;

		case 4:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_VL1, ID_OPTION_VL5, ID_OPTION_VL4, MF_BYCOMMAND);
			break;

		case 5:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_VL1, ID_OPTION_VL5, ID_OPTION_VL5, MF_BYCOMMAND);
			break;

		default:
			CheckMenuRadioItem(hAppMenu, ID_OPTION_VL1, ID_OPTION_VL5, ID_OPTION_VL1, MF_BYCOMMAND);
			break;
	}
	//Mute Sound
	CheckMenuItem(hAppMenu, ID_OPTION_MUTE, (Settings.Mute ? MFS_CHECKED : MFS_UNCHECKED));
	//t[[g\
	CheckMenuItem(hAppMenu, ID_OPTION_FPS, (Settings.DisplayFrameRate ? MFS_CHECKED : MFS_UNCHECKED));

	//ݒ؂芷j[
	if(Options.JPenvFlag)
		CheckMenuItem(hAppMenu, ID_OPTION_JP, MFS_CHECKED);

	//{[xVXej[`FbN
		switch(Options.VolumeLevel)
		{
			case 1:
				CheckMenuRadioItem(hSysMenu, ID_OPTION_VL1, ID_OPTION_VL5, ID_OPTION_VL1, MF_BYCOMMAND);
				break;

			case 2:
				CheckMenuRadioItem(hSysMenu, ID_OPTION_VL1, ID_OPTION_VL5, ID_OPTION_VL2, MF_BYCOMMAND);
				break;

			case 3:
				CheckMenuRadioItem(hSysMenu, ID_OPTION_VL1, ID_OPTION_VL5, ID_OPTION_VL3, MF_BYCOMMAND);
				break;

			case 4:
				CheckMenuRadioItem(hSysMenu, ID_OPTION_VL1, ID_OPTION_VL5, ID_OPTION_VL4, MF_BYCOMMAND);
				break;

			case 5:
				CheckMenuRadioItem(hSysMenu, ID_OPTION_VL1, ID_OPTION_VL5, ID_OPTION_VL5, MF_BYCOMMAND);
				break;

			default:
				CheckMenuRadioItem(hSysMenu, ID_OPTION_VL1, ID_OPTION_VL5, ID_OPTION_VL1, MF_BYCOMMAND);
				break;
		}

	StateSaveLoadMenuSet();

	if(GUI.StopEmulation || (GUI.PauseEmulation && GUI.FullScreen))
	{
	/* t@C */
		//Q[ԃZ[u
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_1, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_2, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_3, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_4, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_5, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_6, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_7, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_8, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_9, MFS_GRAYED);
		//Q[ԃ[h
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_1, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_2, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_3, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_4, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_5, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_6, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_7, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_8, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_9, MFS_GRAYED);
		//XN[Vbgۑ
		EnableMenuItem(hAppMenu, ID_FILE_SCREENSHOT, MFS_GRAYED);
		//SPCzo
		EnableMenuItem(hAppMenu, ID_FILE_SPCDUMP, MFS_GRAYED);
	}
	else {
	/* t@C */
		//Q[ԃZ[u
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_1, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_2, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_3, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_4, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_5, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_6, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_7, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_8, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_SAVESLOT_9, MFS_ENABLED);
#if 0
		//Q[ԃ[h
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_1, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_2, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_3, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_4, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_5, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_6, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_7, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_8, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_FILE_LOADSLOT_9, MFS_ENABLED);
#endif
		//XN[Vbgۑ
		EnableMenuItem(hAppMenu, ID_FILE_SCREENSHOT, MFS_ENABLED);
		//SPCzo
		EnableMenuItem(hAppMenu, ID_FILE_SPCDUMP, MFS_ENABLED);
	}

	//ǂݍłȂԁASPCvC[ԁA|[Y
	if(GUI.StopEmulation)
	{
	/* t@C */
		//Zbg
		EnableMenuItem(hAppMenu, ID_FILE_RESET, MFS_GRAYED);
		//\tgZbg
		EnableMenuItem(hAppMenu, ID_FILE_SOFTRESET, MFS_GRAYED);

	/* IvV */
		//Snes9x ݒύXL[
		CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_1, MFS_CHECKED);
		EnableMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_1, MFS_GRAYED);
		CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_2, MFS_CHECKED);
		EnableMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_2, MFS_GRAYED);
		CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_3, MFS_CHECKED);
		EnableMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_3, MFS_GRAYED);
		CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_4, MFS_CHECKED);
		EnableMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_4, MFS_GRAYED);
		CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_5, MFS_CHECKED);
		EnableMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_5, MFS_GRAYED);
		//Snes9x ݒύXL[  Snes̓foCXύX
#if 0
		if(Settings.ControllerOption == SNES_JOYPAD)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESMULTIPLAYER5, ID_OPTION_SNESJOYPAD, MF_BYCOMMAND);
		else if(Settings.ControllerOption == SNES_MOUSE_SWAPPED && Settings.Mouse)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESMULTIPLAYER5, ID_OPTION_SNESMOUSE1, MF_BYCOMMAND);
		else if(Settings.ControllerOption == SNES_MOUSE && Settings.Mouse)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESMULTIPLAYER5, ID_OPTION_SNESMOUSE0, MF_BYCOMMAND);
		else if(Settings.ControllerOption == SNES_SUPERSCOPE && Settings.SuperScope)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESMULTIPLAYER5, ID_OPTION_SNESSUPERSCOPE, MF_BYCOMMAND);
		else if(Settings.ControllerOption == SNES_JUSTIFIER && Settings.Justifier)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESMULTIPLAYER5, ID_OPTION_SNESJUSTIFIER, MF_BYCOMMAND);
		else if(Settings.ControllerOption == SNES_MULTIPLAYER5 && Settings.MultiPlayer5)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESMULTIPLAYER5, ID_OPTION_SNESMULTIPLAYER5, MF_BYCOMMAND);
#endif
		if(Settings.ControllerOption == SNES_JOYPAD)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESJUSTIFIER, ID_OPTION_SNESJOYPAD, MF_BYCOMMAND);
		else if(Settings.ControllerOption == SNES_MOUSE_SWAPPED && Settings.Mouse)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESJUSTIFIER, ID_OPTION_SNESMOUSE1, MF_BYCOMMAND);
		else if(Settings.ControllerOption == SNES_MOUSE && Settings.Mouse)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESJUSTIFIER, ID_OPTION_SNESMOUSE0, MF_BYCOMMAND);
		else if(Settings.ControllerOption == SNES_SUPERSCOPE && Settings.SuperScope)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESJUSTIFIER, ID_OPTION_SNESSUPERSCOPE, MF_BYCOMMAND);
		else if(Settings.ControllerOption == SNES_JUSTIFIER && Settings.Justifier)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESJUSTIFIER, ID_OPTION_SNESJUSTIFIER, MF_BYCOMMAND);
		else if(Settings.ControllerOption == SNES_MULTIPLAYER5 && Settings.MultiPlayer5)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESJUSTIFIER, ID_OPTION_SNESMULTIPLAYER5, MF_BYCOMMAND);

		EnableMenuItem(hAppMenu, ID_OPTION_SNESJOYPAD, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_OPTION_SNESMOUSE1, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_OPTION_SNESMOUSE0, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_OPTION_SNESSUPERSCOPE, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_OPTION_SNESJUSTIFIER, MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_OPTION_SNESMULTIPLAYER5, MFS_GRAYED);
	}
	else
	{
	/* t@C */
		if(XppMovie.Replay_status == MOVIE_NONE)
		{
			//Zbg
			EnableMenuItem(hAppMenu, ID_FILE_RESET, MFS_ENABLED);
			//\tgZbg
			EnableMenuItem(hAppMenu, ID_FILE_SOFTRESET, MFS_ENABLED);
		}
		else
		{
			//Zbg
			EnableMenuItem(hAppMenu, ID_FILE_RESET, MFS_GRAYED);
			//\tgZbg
			EnableMenuItem(hAppMenu, ID_FILE_SOFTRESET, MFS_GRAYED);
		}

	/* IvV */
		//Snes9x ݒύXL[
		CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_1, (PPU.BG_Forced & 1) ? MFS_UNCHECKED : MFS_CHECKED);
		EnableMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_1, MFS_ENABLED);
		CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_2, (PPU.BG_Forced & 2) ? MFS_UNCHECKED : MFS_CHECKED);
		EnableMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_2, MFS_ENABLED);
		CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_3, (PPU.BG_Forced & 4) ? MFS_UNCHECKED : MFS_CHECKED);
		EnableMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_3, MFS_ENABLED);
		CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_4, (PPU.BG_Forced & 8) ? MFS_UNCHECKED : MFS_CHECKED);
		EnableMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_4, MFS_ENABLED);
		CheckMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_5, (PPU.BG_Forced & 16) ? MFS_UNCHECKED : MFS_CHECKED);
		EnableMenuItem(hAppMenu, ID_OPTION_SETTINGS_KEY_5, MFS_ENABLED);
		//Snes9x ݒύXL[  Snes̓foCXύX
#if 0
		if(IPPU.Controller == SNES_JOYPAD)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESMULTIPLAYER5, ID_OPTION_SNESJOYPAD, MF_BYCOMMAND);
		else if(IPPU.Controller == SNES_MOUSE_SWAPPED)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESMULTIPLAYER5, ID_OPTION_SNESMOUSE1, MF_BYCOMMAND);
		else if(IPPU.Controller == SNES_MOUSE)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESMULTIPLAYER5, ID_OPTION_SNESMOUSE0, MF_BYCOMMAND);
		else if(IPPU.Controller == SNES_SUPERSCOPE)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESMULTIPLAYER5, ID_OPTION_SNESSUPERSCOPE, MF_BYCOMMAND);
		else if(IPPU.Controller == SNES_JUSTIFIER)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESMULTIPLAYER5, ID_OPTION_SNESJUSTIFIER, MF_BYCOMMAND);
		else if(IPPU.Controller == SNES_MULTIPLAYER5)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESMULTIPLAYER5, ID_OPTION_SNESMULTIPLAYER5, MF_BYCOMMAND);
#endif
		if(IPPU.Controller == SNES_JOYPAD)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESJUSTIFIER, ID_OPTION_SNESJOYPAD, MF_BYCOMMAND);
		else if(IPPU.Controller == SNES_MOUSE_SWAPPED)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESJUSTIFIER, ID_OPTION_SNESMOUSE1, MF_BYCOMMAND);
		else if(IPPU.Controller == SNES_MOUSE)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESJUSTIFIER, ID_OPTION_SNESMOUSE0, MF_BYCOMMAND);
		else if(IPPU.Controller == SNES_SUPERSCOPE)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESJUSTIFIER, ID_OPTION_SNESSUPERSCOPE, MF_BYCOMMAND);
		else if(IPPU.Controller == SNES_JUSTIFIER)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESJUSTIFIER, ID_OPTION_SNESJUSTIFIER, MF_BYCOMMAND);
		else if(IPPU.Controller == SNES_MULTIPLAYER5)
			CheckMenuRadioItem(hAppMenu, ID_OPTION_SNESJOYPAD, ID_OPTION_SNESJUSTIFIER, ID_OPTION_SNESMULTIPLAYER5, MF_BYCOMMAND);


		EnableMenuItem(hAppMenu, ID_OPTION_SNESJOYPAD, MFS_ENABLED);
		EnableMenuItem(hAppMenu, ID_OPTION_SNESMOUSE1, Settings.Mouse ? MFS_ENABLED : MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_OPTION_SNESMOUSE0, Settings.Mouse ? MFS_ENABLED : MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_OPTION_SNESSUPERSCOPE, Settings.SuperScope ? MFS_ENABLED : MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_OPTION_SNESJUSTIFIER, Settings.Justifier ? MFS_ENABLED : MFS_GRAYED);
		EnableMenuItem(hAppMenu, ID_OPTION_SNESMULTIPLAYER5, Settings.MultiPlayer5 ? MFS_ENABLED : MFS_GRAYED);
	}
}

static bool GetFileTimeStringError = FALSE;

char *GetFileTimeString(char *Fname)
{
	FILETIME fLocTime;
	SYSTEMTIME sysTime;
	HANDLE hFind;
	WIN32_FIND_DATA w32fd;
	hFind = FindFirstFile(Fname, &w32fd);
	if(hFind == INVALID_HANDLE_VALUE) {
		GetFileTimeStringError = TRUE;
		return (char *)(GUI.Language ? "" : "Empty");
	}
	FindClose(hFind);
	static char FileTimeStr[256];
	FileTimeToLocalFileTime(&w32fd.ftLastWriteTime, &fLocTime);
	FileTimeToSystemTime(&fLocTime, &sysTime);
	wsprintf(FileTimeStr, "%04d/%02d/%02d %02d:%02d:%02d", sysTime.wYear, sysTime.wMonth, sysTime.wDay, sysTime.wHour, sysTime.wMinute, sysTime.wSecond);
	GetFileTimeStringError = FALSE;
	return FileTimeStr;
}

extern "C" const char *S9xGetFilename (const char *e);

void StateSaveLoadMenuSet()
{
	char StateSaveLoadMenuString[100];
	char KeyNumberStr[2];
	char saveloadext[_MAX_EXT];
	lstrcpy(StateSaveLoadMenuString, GUI.Language ? "Slot #&" : "Slot #&");
	if(GUI.StopEmulation)
	{
		for(i = 0; i < 9; i++) {
			wsprintf(&StateSaveLoadMenuString[7], "%d", i + 1);
			lstrcat(StateSaveLoadMenuString, "\tShift+F");
			wsprintf(KeyNumberStr, "%d", i + 1);
			lstrcat(StateSaveLoadMenuString, KeyNumberStr);
			ModifyMenu(GUI.hMenu, ID_FILE_SAVESLOT_1 + i, MF_BYCOMMAND, ID_FILE_SAVESLOT_1 + i, StateSaveLoadMenuString);
			wsprintf(&StateSaveLoadMenuString[7], "%d", i + 1);
			lstrcat(StateSaveLoadMenuString, "\tF");
			lstrcat(StateSaveLoadMenuString, KeyNumberStr);
			ModifyMenu(GUI.hMenu, ID_FILE_LOADSLOT_1 + i, MF_BYCOMMAND, ID_FILE_LOADSLOT_1 + i, StateSaveLoadMenuString);
		}
	}
	else {
		for(i = 0; i < 9; i++) {
			wsprintf(&StateSaveLoadMenuString[7], "%d", i + 1);
			wsprintf(saveloadext, ".%03d", i);
			//Xbgԍ̃Z[ut@C݂Ȃꍇ
			if(GetFileAttributes(S9xGetFilename(saveloadext)) == 0xffffffff) {
				lstrcat(StateSaveLoadMenuString, GUI.Language ? "  " : "  Empty");
				lstrcat(StateSaveLoadMenuString, "\tShift+F");
				wsprintf(KeyNumberStr, "%d", i + 1);
				lstrcat(StateSaveLoadMenuString, KeyNumberStr);
				ModifyMenu(GUI.hMenu, ID_FILE_SAVESLOT_1 + i, MF_BYCOMMAND, ID_FILE_SAVESLOT_1 + i, StateSaveLoadMenuString);
				wsprintf(&StateSaveLoadMenuString[7], "%d", i + 1);
				lstrcat(StateSaveLoadMenuString, GUI.Language ? "  " : "  Empty");
				lstrcat(StateSaveLoadMenuString, "\tF");
				lstrcat(StateSaveLoadMenuString, KeyNumberStr);
				ModifyMenu(GUI.hMenu, ID_FILE_LOADSLOT_1 + i, MF_BYCOMMAND, ID_FILE_LOADSLOT_1 + i, StateSaveLoadMenuString);
				EnableMenuItem(GUI.hMenu, ID_FILE_LOADSLOT_1 + i, MFS_GRAYED);
			}
			//Xbgԍ̃Z[ut@C݂ꍇ
			else {
				lstrcat(StateSaveLoadMenuString, "  ");
				lstrcat(StateSaveLoadMenuString, GetFileTimeString((char *)S9xGetFilename(saveloadext)));
				lstrcat(StateSaveLoadMenuString, "\tShift+F");
				wsprintf(KeyNumberStr, "%d", i + 1);
				lstrcat(StateSaveLoadMenuString, KeyNumberStr);
				ModifyMenu(GUI.hMenu, ID_FILE_SAVESLOT_1 + i, MF_BYCOMMAND, ID_FILE_SAVESLOT_1 + i, StateSaveLoadMenuString);
				wsprintf(&StateSaveLoadMenuString[7], "%d", i + 1);
				lstrcat(StateSaveLoadMenuString, "  ");
				lstrcat(StateSaveLoadMenuString, GetFileTimeString((char *)S9xGetFilename(saveloadext)));
				lstrcat(StateSaveLoadMenuString, "\tF");
				lstrcat(StateSaveLoadMenuString, KeyNumberStr);
				ModifyMenu(GUI.hMenu, ID_FILE_LOADSLOT_1 + i, MF_BYCOMMAND, ID_FILE_LOADSLOT_1 + i, StateSaveLoadMenuString);
				if(!GetFileTimeStringError)
					EnableMenuItem(GUI.hMenu, ID_FILE_LOADSLOT_1 + i, MFS_ENABLED);
				else
					EnableMenuItem(GUI.hMenu, ID_FILE_LOADSLOT_1 + i, MFS_GRAYED);
			}
		}
	}
}

int RecentROMFileNameDuplicateCheck(int listindex)
{
	int dupret = TRUE;
	if(!RecentROMFileName[_MAX_PATH * listindex])
		return !dupret;
	for(int listindex2 = listindex + 1; listindex2 < 10 && dupret; listindex2++)
		dupret = lstrcmp(&RecentROMFileName[_MAX_PATH * listindex2], &RecentROMFileName[_MAX_PATH * listindex]);
	return !dupret;
}

void SetRecentFileMenu()
{
	//ŋߓǂݍ񂾃XgXV
	if(ROMFileName[0]
	&& lstrcmp(&RecentROMFileName[_MAX_PATH * 0], ROMFileName)
	&& lstrcmp(&RecentROMFileName[_MAX_PATH * 1], ROMFileName)
	&& lstrcmp(&RecentROMFileName[_MAX_PATH * 2], ROMFileName)
	&& lstrcmp(&RecentROMFileName[_MAX_PATH * 3], ROMFileName)
	&& lstrcmp(&RecentROMFileName[_MAX_PATH * 4], ROMFileName)
	&& lstrcmp(&RecentROMFileName[_MAX_PATH * 5], ROMFileName)
	&& lstrcmp(&RecentROMFileName[_MAX_PATH * 6], ROMFileName)
	&& lstrcmp(&RecentROMFileName[_MAX_PATH * 7], ROMFileName)
	&& lstrcmp(&RecentROMFileName[_MAX_PATH * 8], ROMFileName)
	&& lstrcmp(&RecentROMFileName[_MAX_PATH * 9], ROMFileName))
	{
		memmove((void *)&RecentROMFileName[_MAX_PATH * 1], (void *)&RecentROMFileName[_MAX_PATH * 0], _MAX_PATH * 9);
		lstrcpy(&RecentROMFileName[_MAX_PATH * 0], ROMFileName);
	}

	//̂ꍇԏɎĂ
	else if(ROMFileName[0]) {
		for(i = 1; i < 10; i++) {
			if(!lstrcmp(ROMFileName, &RecentROMFileName[_MAX_PATH * i])) {
				memmove((void *)&RecentROMFileName[_MAX_PATH * 1], (void *)RecentROMFileName, _MAX_PATH * i);
				lstrcpy(RecentROMFileName, ROMFileName);
				break;
			}
		}
	}

	//Xg̋󂫗LAdt@CA܂݂͑Ȃt@C̖Ȍꍇl߂
	for(i = 0; i < 10; i++) {
		for(i2 = i; i2 < 10; i2++) {
			if(!RecentROMFileName[_MAX_PATH * i] || RecentROMFileNameDuplicateCheck(i) || GetFileAttributes(&RecentROMFileName[_MAX_PATH * i]) == 0xffffffff)
				memmove((void *)&RecentROMFileName[_MAX_PATH * i], (void *)&RecentROMFileName[_MAX_PATH * (i + 1)], (_MAX_PATH * 11) - (_MAX_PATH * (i + 1)));
		}
	}
	
	//ŋߓǂݍ񂾃
	if(RecentROMFileName[_MAX_PATH * 0] || RecentROMFileName[_MAX_PATH * 1] || RecentROMFileName[_MAX_PATH * 2] || RecentROMFileName[_MAX_PATH * 3] || RecentROMFileName[_MAX_PATH * 4]
		|| RecentROMFileName[_MAX_PATH * 5] || RecentROMFileName[_MAX_PATH * 6] || RecentROMFileName[_MAX_PATH * 7] || RecentROMFileName[_MAX_PATH * 8] || RecentROMFileName[_MAX_PATH * 9]) {
		if(GUI.hRecentGamesMenu) {
			DeleteMenu(GetSubMenu(GUI.hMenu, 0), 1, MF_BYPOSITION | MF_POPUP);
			DestroyMenu(GUI.hRecentGamesMenu);
		}
		GUI.hRecentGamesMenu = CreatePopupMenu();
		char RecentGamesMenuStrings[_MAX_PATH];
		lstrcpy(RecentGamesMenuStrings, "&1. ");
		for(i = 0; i < 10; i++) {
			if(RecentROMFileName[_MAX_PATH * i]) {
				wsprintf(&RecentGamesMenuStrings[1], "%X", i + 1);
				RecentGamesMenuStrings[2] = '.';
				lstrcpyn(&RecentGamesMenuStrings[4] , S9xBasename(&RecentROMFileName[_MAX_PATH * i]), _MAX_PATH - 5);
				RecentGamesMenuStrings[_MAX_PATH - 1] = 0;
				AppendMenu(GUI.hRecentGamesMenu, MFT_STRING, ID_FILE_RECENT1 + i, RecentGamesMenuStrings);
				EnableMenuItem(GUI.hRecentGamesMenu, ID_FILE_RECENT1 + i, GUI.PauseEmulation ? MFS_GRAYED : MFS_ENABLED);
			}
		}
		InsertMenu(GetSubMenu(GUI.hMenu, 0), 1, MF_BYPOSITION | MF_POPUP, (UINT)GUI.hRecentGamesMenu, GUI.Language ? "ŋߓǂݍ񂾃(&G)" : "Recent &Games");
	}
	else {
		if(GUI.hRecentGamesMenu) {
			DeleteMenu(GetSubMenu(GUI.hMenu, 0), 1, MF_BYPOSITION | MF_POPUP);
			DestroyMenu(GUI.hRecentGamesMenu);
			GUI.hRecentGamesMenu = 0;
		}
	}
}
