#include "../snes9x.h"
#include "../memmap.h"
#include "../ppu.h"
#include "../display.h"
#include "../apu.h"
#include "../soundux.h"
#include "cdda.h"

void S9xSetInfoString (const char *string);

/*********************************************************************************************/
/* CDDA                                                                                      */
/*********************************************************************************************/

void cdda_play()
{
	XPP_CDPLAY();
}

void cdda_replay()
{
	XPP_CDREPLAY();

}

void cdda_pause()
{
	XPP_CDPAUSE();
	
}

void cdda_stop()
{
	XPP_CDSTOP();
}

void cdda_exit()
{
	XPP_CDEXIT();
}

void cdda_open()
{
	XPP_CDOPEN();
}

void XPP_CDPLAY()
{
	CDROM_MCIPlayCD();
}

void XPP_CDREPLAY()
{
	CDROM_MCIRePlayCD();
}

void XPP_CDPAUSE()
{
	CDROM_MCIPauseCD();
}

void XPP_CDSTOP()
{
	CDROM_MCIStopCD();
}

void XPP_CDEXIT()
{
	CDROM_MCICloseCD();
}

void XPP_CDOPEN()
{
	CDROM_MCIOpenCD();
}
