#define ROMCHEAT_CLEAR  0x11
#define ROMCHEAT_CODE  0x12
#define ROMCHEAT_SELECT  0x13
#define ROMCHEAT_LOCK  0x14
#define ROMCHEAT_LOCK_CLEAR  0x15
#define ROMCHEAT_RUN  0x16

#define REPLAY_RAM_SIZE  0x800000
#define REPLAY_FRAME_CHECK_SIZE 0x80000
#define REPLAY_CHEAT_KEY_SIZE 0x8000

#define REPLAY_HEADER_POINT (REPLAY_RAM_SIZE - 0x40)

#define REPLAY_SAVE  0
#define REPLAY_LOAD  1
#define REPLAY_CLEAR  2
#define REPLAY_PPU_LOAD  3

#define MOVIE_NONE   0
#define MOVIE_PLAY   0x20
#define MOVIE_RECODE 0x21

#define LOROM_ROMIMAGE(gamename,cartname,lan,xxx) \
if (Memory.LoROM && strncmp ((char *) &Memory.ROM [0x7fc0], cartname, lan) == 0) \
\

#define HIROM_ROMIMAGE(gamename,cartname,lan,xxx) \
if (Memory.HiROM && strncmp ((char *) &Memory.ROM [0xffc0], cartname, lan) == 0) \
\

START_EXTERN_C

void ROMSETEXTRA ();
void ROMSETEXTRA_OLD ();
void VOICERKUN_MEMORYFIX ();

void Xpp_Lock_Cheat();

void XPP_ROMCHEAT_CODE (int codetype);

void ROMCHEAT_CODE_JAPAN (int codetype);
void ROMCHEAT_CODE_USA (int codetype);

void ROMCHEAT_SELECT_JAPAN ();
void ROMCHEAT_RUN_JAPAN ();
void ROMCHEAT_LOCK_JAPAN ();
void ROMCHEAT_SELECT_USA ();
void ROMCHEAT_RUN_USA ();
void ROMCHEAT_LOCK_USA ();

void BSX_CLEAR ();
void BSX_WAIT_TIMER_SET ();
void BSX_WAIT_TIMER_GET ();
void BSX_SRAMFIRST ();
void BSX_TIMESKIP ();
void BSX_TIMEBACK ();
void BSX_WORK ();
void BSX_WORKEXTRA ();
void BSX_TIMESET ();
void BSX_MEMORYFIX ();
void BSX_CDAUDIO ();
void ROMBSSETEXTRA ();
void ROMBSFONTEXTRA ();

void BIOS_BSXBIOS_LOAD ();
void BIOS_BSXPSRAM_LOAD ();
void BIOS_BSXFONT_SET ();
void BIOS_SFMT_LOAD ();
void EXCART_SAMEGAME_LOAD ();

void XPP_REPLAY_LOAD (const char *Xpp_ext);
void XPP_REPLAY_SAVE (const char *Xpp_ext);
void XPP_REPLAY_START ();
void XPP_REPLAY_END ();
void XPP_REPLAY_RESUME (int mode);
void XPP_REPLAY_CHECK ();
void XPP_REPLAY_EXT_SET ();
void XPP_REPLAY_CHEAT_KEY (int codetype);
void XPP_REPLAY_TIME_H_M_S (uint32 time);

void XPP_CDPLAY ();
void XPP_CDREPLAY ();
void XPP_CDPAUSE ();
void XPP_CDSTOP ();
void XPP_CDOPEN ();
void XPP_CDEXIT();
void cdda_play();
void cdda_replay();
void cdda_pause();
void cdda_stop();
void cdda_exit();
void cdda_open();

END_EXTERN_C
